'use strict';

var _loaderUtils = require('loader-utils');

var _loaderUtils2 = _interopRequireDefault(_loaderUtils);

var _TraverseImport = require('./TraverseImport');

var _TraverseImport2 = _interopRequireDefault(_TraverseImport);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * remove universal-env module dependencies
 * convert to constant
 * then use babel-plugin-minify-dead-code-elimination remove the dead code
 *
 * @example
 *
 * ../evn-loader/lib/index?isWeex=true
 *
 * `import { isWeex, isWeb } from 'universal-env'`;
 *
 * after:
 *
 * ```
 * const isWeex = true;
 * const isWeb = false
 * ```
 */
module.exports = function (inputSource, inputSourceMap) {
  this.cacheable();
  var callback = this.async();

  var loaderOptions = _loaderUtils2.default.parseQuery(this.query);

  var options = Object.assign({ name: 'universal-env' }, loaderOptions);

  var _traverseImport = (0, _TraverseImport2.default)(options, inputSource),
      code = _traverseImport.code;

  callback(null, code, inputSourceMap);
};